Package org.apache.sysds.runtime.compress.colgroup.dictionary

## Class ACachingMBDictionary

- java.lang.Object
- - org.apache.sysds.runtime.compress.colgroup.dictionary.ADictionary
  - - org.apache.sysds.runtime.compress.colgroup.dictionary.ACachingMBDictionary

All Implemented Interfaces:
  `Serializable`, `IDictionary`

Direct Known Subclasses:
  `AIdentityDictionary`, `Dictionary`, `QDictionary`

    public abstract class ACachingMBDictionary
    extends ADictionary

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.apache.sysds.runtime.compress.colgroup.dictionary.IDictionary

`IDictionary.DictType`

### Field Summary

### Fields inherited from interface org.apache.sysds.runtime.compress.colgroup.dictionary.IDictionary

`LOG`

### Constructor Summary

Constructors
`ACachingMBDictionary()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract MatrixBlockDictionary` `createMBDict​(int nCol)`
`MatrixBlockDictionary` `getMBDict​(int nCol)` Get this dictionary as a MatrixBlock dictionary.

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.dictionary.ADictionary

`addToEntry, addToEntry, addToEntryVectorized, aggregate, aggregateCols, aggregateColsWithReference, aggregateRows, aggregateRowsWithDefault, aggregateRowsWithReference, aggregateWithReference, append, applyScalarOp, applyScalarOpAndAppend, applyScalarOpWithReference, applyUnaryOp, applyUnaryOpAndAppend, applyUnaryOpWithReference, binOpLeft, binOpLeftAndAppend, binOpLeftWithReference, binOpRight, binOpRight, binOpRightAndAppend, binOpRightWithReference, cbind, centralMoment, centralMoment, centralMomentWithDefault, centralMomentWithDefault, centralMomentWithReference, centralMomentWithReference, clone, colProduct, colProductWithReference, colSum, colSumSq, colSumSqWithReference, containsValue, containsValueWithReference, correctNan, countNNZZeroColumns, equals, equals, getMBDict, getNumberNonZerosWithReference, getRow, getSparsity, getValue, getValue, getValues, MMDict, MMDictDense, MMDictScaling, MMDictScalingDense, MMDictScalingSparse, MMDictSparse, multiplyScalar, preaggValuesFromDense, product, productAllRowsToDouble, productAllRowsToDoubleWithDefault, productAllRowsToDoubleWithReference, productWithDefault, productWithReference, putDense, putSparse, reorder, replace, replaceWithReference, rexpandCols, rexpandColsWithReference, rightMMPreAggSparse, scaleTuples, sliceOutColumnRange, subtractTuple, sum, sumAllRowsToDouble, sumAllRowsToDoubleSq, sumAllRowsToDoubleSqWithDefault, sumAllRowsToDoubleSqWithReference, sumAllRowsToDoubleWithDefault, sumAllRowsToDoubleWithReference, sumSq, sumSqWithReference, TSMMToUpperTriangle, TSMMToUpperTriangleDense, TSMMToUpperTriangleDenseScaling, TSMMToUpperTriangleScaling, TSMMToUpperTriangleSparse, TSMMToUpperTriangleSparseScaling, TSMMWithScaling`

### Methods inherited from class java.lang.Object

`getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.sysds.runtime.compress.colgroup.dictionary.IDictionary

`equals, getDictType, getExactSizeOnDisk, getInMemorySize, getNumberNonZeros, getNumberOfColumns, getNumberOfValues, getString, write`

### Constructor Detail

#### ACachingMBDictionary

    public ACachingMBDictionary()

### Method Detail

#### getMBDict

    public final MatrixBlockDictionary getMBDict​(int nCol)

Description copied from interface: `IDictionary`
Get this dictionary as a MatrixBlock dictionary. This allows us to use optimized kernels coded elsewhere in the system, such as matrix multiplication. Return null if the matrix is empty.

Specified by:
  `getMBDict` in interface `IDictionary`
Overrides:
  `getMBDict` in class `ADictionary`
Parameters:
  `nCol` - The number of columns contained in this column group.
Returns:
  A Dictionary containing a MatrixBlock.

#### createMBDict

    public abstract MatrixBlockDictionary createMBDict​(int nCol)